#include <curl/curl.h>
#include <curl/easy.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#include "hscurl.h"

static CURL *c = NULL;

int curl_init_globally() {
  curl_global_init(CURL_GLOBAL_ALL);
  if (c == NULL) c = curl_easy_init();
}

// get_curl returns an error code
int get_curl(const char *filename, const char *url) {
  CURLcode err;
  FILE *f = fopen(filename,"wb");
  if (f == NULL) return -1;
  if (c == NULL) curl_init_globally();
  if (c == NULL) return -2;

  err = curl_easy_setopt(c, CURLOPT_URL, url);
  /*curl_easy_setopt(c, CURLOPT_NOSIGNAL, NULL);*/
  err += curl_easy_setopt(c, CURLOPT_WRITEDATA, f);
  err += curl_easy_setopt(c, CURLOPT_FAILONERROR, 1);
  err += curl_easy_perform(c);
  fclose(f);
  return (int) err;
}

